//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <IniFiles.hpp>
#include "App_Common.h"
#include "Moa_AutoPointers.h"
#include "Moa_Strings.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_common {
//---------------------------------------------------------------------------
const AnsiString TCommon::Title = "D88 Edit";
const AnsiString TCommon::About = "D88 Edit 2.0.0\r\n\r\nCopyright (C) 2011-2012 Moochos. All rights reserved.";
const AnsiString TCommon::HelpFile = ExtractFilePath(Application->ExeName) + "Help\\index.html";
const AnsiString TCommon::SettingsFile = ExtractFilePath(Application->ExeName) + "Settings.ini";
//---------------------------------------------------------------------------
AnsiString __fastcall TCommon::FormatInteger(int AValue)
{
	return TAnsiStringUtilities::FormatInteger(AValue, 3, ',');
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCommon::FormatInteger(__int64 AValue)
{
	return TAnsiStringUtilities::FormatInteger(AValue, 3, ',');
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TSettingsHandler::TSettingsHandler() :
	TObject()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TSettingsHandler::~TSettingsHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandler::LoadSettings(TMemIniFile* ASettings, const AnsiString& ASection)
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandler::SaveSettings(TMemIniFile* ASettings, const AnsiString& ASection)
{
	// Do nothing
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::Initialize()
{
	try {
		FList = new TStringList();
		FList->CaseSensitive = false;
		FList->Duplicates = dupError;
		FList->Sorted = true;
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::Uninitialize()
{
	delete FList;
	FList = NULL;
}
//---------------------------------------------------------------------------
__fastcall TSettingsHandlers::TSettingsHandlers() :
	TObject(),
	FList(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TSettingsHandlers::~TSettingsHandlers()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::Add(TSettingsHandler* AHandler, const AnsiString& ASection)
{
	if(List->IndexOfObject(AHandler) >= 0) {
		throw EAppError("The program cannot add the settings handler.");
	}
	List->AddObject(ASection, AHandler);
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::Remove(TSettingsHandler* AHandler)
{
	List->Delete(List->IndexOfObject(AHandler));
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::Clear()
{
	List->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::LoadSettings()
{
	if(!FileExists(TCommon::SettingsFile)) {
		return;
	}
	TAutoPointer<TMemIniFile> LSettings = new TMemIniFile(TCommon::SettingsFile);
	for(int LI = 0; LI < List->Count; ++LI) {
		static_cast<TSettingsHandler*>(List->Objects[LI])->LoadSettings(LSettings, List->Strings[LI]);
	}
}
//---------------------------------------------------------------------------
void __fastcall TSettingsHandlers::SaveSettings()
{
	TAutoPointer<TMemIniFile> LSettings = new TMemIniFile(TCommon::SettingsFile);
	LSettings->Clear();
	for(int LI = 0; LI < List->Count; ++LI) {
		static_cast<TSettingsHandler*>(List->Objects[LI])->SaveSettings(LSettings, List->Strings[LI]);
	}
	LSettings->UpdateFile();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TModel::TModel() :
	TSettingsHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TModel::~TModel()
{
	// Do nothing
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TView::TView() :
	TSettingsHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TView::~TView()
{
	// Do nothing
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TCommands::HandleFeatureUnavailable()
{
	throw EAppError("The feature is unavailable.");
}
//---------------------------------------------------------------------------
__fastcall TCommands::TCommands() :
	TSettingsHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TCommands::~TCommands()
{
	// Do nothing
}
//---------------------------------------------------------------------------
} // End namespace App_common
//---------------------------------------------------------------------------

