//---------------------------------------------------------------------------
#ifndef App_HistoryH
#define App_HistoryH
//---------------------------------------------------------------------------
#include "App_Common.h"
namespace Actnlist {class TAction;} using namespace Actnlist;
//---------------------------------------------------------------------------
namespace App_history {
//---------------------------------------------------------------------------
class THistoryModel : public TModel
{
private:
	TStrings* FList;
	int FLimit;
	TNotifyEvent FOnChange;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	AnsiString __fastcall GetItem(int AIndex);
	int __fastcall GetCount();
	void __fastcall SetLimit(int ALimit);
	__property TStrings* List = {read=FList};
protected:
	virtual void __fastcall DoChange();
public:
	__fastcall THistoryModel();
	virtual __fastcall ~THistoryModel();
	virtual int __fastcall Add(const AnsiString& AItem);
	virtual int __fastcall Remove(const AnsiString& AItem);
	virtual void __fastcall Delete(int AIndex);
	virtual void __fastcall Clear();
	virtual int __fastcall Find(const AnsiString& AItem);
	virtual void __fastcall LoadSettings(TMemIniFile* ASettings, const AnsiString& ASection);
	virtual void __fastcall SaveSettings(TMemIniFile* ASettings, const AnsiString& ASection);
	__property AnsiString Items[int AIndex] = {read=GetItem};
	__property int Count = {read=GetCount};
	__property int Limit = {read=FLimit, write=SetLimit};
	__property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};
//---------------------------------------------------------------------------
class THistoryView : public TView
{
private:
	THistoryModel* FHistoryModel;
	TList* FList;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	TAction* __fastcall GetItem(int AIndex);
	int __fastcall GetCount();
	__property THistoryModel* HistoryModel = {read=FHistoryModel};
	__property TList* List = {read=FList};
protected:
public:
	__fastcall THistoryView(THistoryModel* AHistoryModel);
	virtual __fastcall ~THistoryView();
	int __fastcall Add(TAction* AItem);
	int __fastcall Remove(TAction* AItem);
	virtual void __fastcall Delete(int AIndex);
	virtual void __fastcall Clear();
	virtual int __fastcall Find(TAction* AItem);
	virtual void __fastcall HandleChange(TObject* ASender);
	__property TAction* Items[int AIndex] = {read=GetItem};
	__property int Count = {read=GetCount};
};
//---------------------------------------------------------------------------
} // End namespace App_history
using namespace App_history;
//---------------------------------------------------------------------------
#endif

